/* AMX Mod script.
*
* (c) Copyright 2002-2003, OLO
* This file is provided as is (no warranties).
*
* Mapcycle is immune to manual map changes and map votes.
*
* Cvars:
* amx_nextmap < mapname > - sets nextmap
*
* Commands:
* say nextmap - dispalys the nextmap (available for all clients)
*/

#include <amxmod>

// Set to 0 and recompile if you want disable that feature
#define IMMUNE_MAPCYCLE 1

new g_NextMap[64]

#if IMMUNE_MAPCYCLE == 1
new g_MapCycle[64]
new g_currentPost
#endif

public plugin_init() {
	register_plugin("NextMap","0.9.4","default")
	register_event( "30" , "forceMap", "a" )
	register_clcmd("say nextmap","sayNextMap",0,"- displays nextmap")
	register_cvar("amx_nextmap","",FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY)
	findNextmap()
	return PLUGIN_CONTINUE
}

getNextMap(szArg[],iMax){
	get_cvar_string("amx_nextmap",szArg,iMax)
	if ( is_map_valid(szArg) ) return
	copy(szArg,iMax,g_NextMap)
	set_cvar_string("amx_nextmap",g_NextMap)
}

public delayedSayInfo(text[])
	client_print(0,print_chat,text)

public sayNextMap(){
	new szArg[96]
	getNextMap(szArg,63)
	new iLen = format(szArg,95,"* The next map:   %s",szArg)
	set_task(0.1,"delayedSayInfo",0,szArg,  iLen + 1 )
	return PLUGIN_CONTINUE
}

public delayedMapChange() {
	new szArg[64]
	getNextMap(szArg, 63)
	server_cmd("changelevel %s",szArg)
}

public forceMap(){

#if IMMUNE_MAPCYCLE == 1

	new szString[128]
	format( szString , 127, "%s %d", g_MapCycle , g_currentPost  )
	set_localinfo( "lastmapcycle", szString )
	
#endif

	set_cvar_float("mp_chattime", 1.9 )
	set_task(1.8,"delayedMapChange")
}

isAlpha(c)
	return ( ( c >= 'a' && c <= 'z' ) || ( c >= 'A' && c <= 'Z' ) )

#if IMMUNE_MAPCYCLE == 1

readMapCycle(szFileName[], szNext[], iNext, iPos )
{	
	new iLen
	new i = 0
	new iMaps = 0
	new szBuffer[64]
	new szFirst[64]

	if ( file_exists( szFileName ) )
	{
		while( read_file( szFileName , i++ , szBuffer , 63 , iLen ) )
		{
			if ( !isAlpha( szBuffer[0] ) || !is_map_valid( szBuffer ) ) continue
		
			if ( !iMaps )	copy( szFirst, 63, szBuffer )

			if ( ++iMaps > iPos )	{
				copy( szNext , iNext , szBuffer  )
				return iMaps
			}
		}
	}
	
	if ( !iMaps ) get_mapname( szFirst , 63 )
	
	copy( szNext , iNext , szFirst  )
	return iPos ? 1 : 0
}

findNextmap() {
	new szString[128], szString2[64], szString3[8]
	get_localinfo( "lastmapcycle", szString , 127 )
	parse( szString, szString2, 63, szString3 , 7 )
	g_currentPost = strtonum( szString3 )
	get_cvar_string( "mapcyclefile" , g_MapCycle , 63 )
	
	if ( !equal( g_MapCycle ,  szString2  )  ) 
		g_currentPost = 0 // mapcycle file has been changed - go from first
	
	g_currentPost = readMapCycle(  g_MapCycle ,  g_NextMap , 63 , g_currentPost )
	set_cvar_string( "amx_nextmap", g_NextMap )
}

#else

readMapCycle(szFileName[], szNext[], iNext )
{	
	new iLen
	new i = 0
	new iMaps = 0
	new szBuffer[64]
	new szFirst[64]
	new szCurrent[64]
	get_mapname( szCurrent , 63 )
	
	if ( file_exists( szFileName ) )
	{
		while( read_file( szFileName , i++ , szBuffer , 63 , iLen ) )
		{
			if ( !isAlpha( szBuffer[0] ) || !is_map_valid( szBuffer ) ) continue

			if ( !iMaps )	{
				iMaps = 1
				copy( szFirst, 63, szBuffer )
			}
			
			if ( iMaps == 1 ){
					if ( equali( szCurrent , szBuffer ) )
						iMaps = 2
			}
			else {
				copy( szNext , iNext , szBuffer )
				return
			}
		}
	}
	
	copy( szNext ,iNext , iMaps ? szFirst : szCurrent )
}

findNextmap() 
{
	new szFilename[64]
	get_cvar_string("mapcyclefile", szFilename , 63 )
	readMapCycle( szFilename , g_NextMap , 63  )
	set_cvar_string("amx_nextmap", g_NextMap )
}

#endif